#include "DAFileDict.h"

#include <stdhdrs.h>
#include <strbuf.h>

#include "DAFile.h"

struct DAFileEntry
{
	StrBuf key;
	DAFile* file;
};

DAFileDict::DAFileDict(void)
{
}

DAFileDict::~DAFileDict(void)
{
	//VarArray does not delete the DAFileEntries
	//that it points to, and DAFileEntry does not
	//delete the DAFile that it points to.
	DAFileEntry* e;
	for ( int i = 0 ; i < array.Count() ; i++ )
	{
		e = (DAFileEntry*)array.Get( i );
		delete e->file;
		delete e;
	}
}

DAFile* DAFileDict::Get( const StrPtr& path )
{
	DAFileEntry* e;
	for ( int i = 0 ; i < array.Count() ; i++ )
	{
		e = (DAFileEntry*)array.Get( i );
		if ( path == e->key ) return e->file;
	}
	return 0x0;
}

bool DAFileDict::Put( const StrPtr& path, DAFile* file )
{
	//Prevent nulls.
	if ( !path.Length() ) return false;

	//Prevent duplicates.
	DAFileEntry* e;
	for ( int i = 0 ; i < array.Count() ; i++ )
	{
		e = (DAFileEntry*)array.Get( i );
		if ( path == e->key ) return false;
	}
	e = new DAFileEntry;
	e->key = path;
	e->file = file;
	array.Put( e );
	return true;
}
